//
//    Copyright (c) 2011 Thomas J. Cashman and Kai Hormann
//                       Tom.Cashman@cantab.net / Kai.Hormann@usi.ch
//
//    This file is part of DefMeshRep.
//
//    DefMeshRep is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    DefMeshRep is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with DefMeshRep.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef DEFGRADREPCONVERTER_H
#define DEFGRADREPCONVERTER_H

#include "RepConverter.h"
#include "DefGradRep.h"

#define EIGEN_YES_I_KNOW_SPARSE_MODULE_IS_NOT_STABLE_YET
#include <Eigen/Sparse>
#include <Eigen/unsupported/CholmodSupport>

class DefGradRepConverter : public RepConverter {
public:
    explicit DefGradRepConverter(const Mesh &refMesh, bool standardRef = false);
    void setMeshFromRep(Mesh &targetMesh, const DefGradRep &rep) const;
    void setRepFromMesh(DefGradRep &rep, const Mesh &targetMesh) const;

private:
    static void fillFrame(const Mesh::FHandle &f, const Mesh &mesh, Eigen::Matrix3d &matrix, int *vInds = 0);

    const bool standardRef;
    std::vector<Eigen::Matrix3d> refFramesInv;
    Eigen::SparseMatrix<double> At;
    Eigen::SparseLLT<Eigen::SparseMatrix<double>, Eigen::Cholmod> factorized_AtA;
};

#endif // DEFGRADREPCONVERTER_H
