//
//    Copyright (c) 2011 Thomas J. Cashman and Kai Hormann
//                       Tom.Cashman@cantab.net / Kai.Hormann@usi.ch
//
//    This file is part of DefMeshRep.
//
//    DefMeshRep is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    DefMeshRep is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with DefMeshRep.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef DOUBLESLIDER_H
#define DOUBLESLIDER_H

#include <QSlider>

class DoubleSlider : public QSlider
{
	Q_OBJECT

public:
    explicit DoubleSlider(QWidget *parent = 0);

    void setMinimum(int);
    int minimum() const;

    void setMaximum(int);
    int maximum() const;

    void setValue(double);
    double value() const;

    void setSnapToIntegers(bool);
    bool snapToIntegers() const;

signals:
    void valueChanged(double);

public slots:
    void setNextIntegerValue();
    void setPrevIntegerValue();

protected:
    void resizeEvent(QResizeEvent *event);
    void keyPressEvent(QKeyEvent *event);

private slots:
    void calcDoubleValue(int);

private:
    void updateQSlider(int newSliderPixValues = -1);

    bool constrainInt;
    int minValue;
    int maxValue;
    double doubleValue;
    int sliderPixValues;
};

#endif // DOUBLESLIDER_H
