//
//    Copyright (c) 2011 Thomas J. Cashman and Kai Hormann
//                       Tom.Cashman@cantab.net / Kai.Hormann@usi.ch
//
//    This file is part of DefMeshRep.
//
//    DefMeshRep is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    DefMeshRep is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with DefMeshRep.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef LINROTINVREPCONVERTER_H
#define LINROTINVREPCONVERTER_H

#include "RepConverter.h"
#include "LinRotInvRep.h"

#define EIGEN_YES_I_KNOW_SPARSE_MODULE_IS_NOT_STABLE_YET
#include <Eigen/Sparse>
#include <Eigen/unsupported/CholmodSupport>

class LinRotInvRepConverter : public RepConverter {
public:
    explicit LinRotInvRepConverter(const Mesh &structure);

    void setMeshFromRep(Mesh &targetMesh, const LinRotInvRep &rep) const;
    void setRepFromMesh(LinRotInvRep &rep, Mesh &targetMesh) const;

private:
    Eigen::SparseMatrix<double> Dt;
    Eigen::SparseLLT<Eigen::SparseMatrix<double>, Eigen::Cholmod> factorized_DtD;
    int interiorHalfedges;
};

#endif // LINROTINVREPCONVERTER_H
