//
//    Copyright (c) 2011 Thomas J. Cashman and Kai Hormann
//                       Tom.Cashman@cantab.net / Kai.Hormann@usi.ch
//
//    This file is part of DefMeshRep.
//
//    DefMeshRep is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    DefMeshRep is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with DefMeshRep.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef MONOTONEINTERPOLATOR_H
#define MONOTONEINTERPOLATOR_H

#include <vector>

class MonotoneInterpolator
{
public:
    void clear();
    void addDataValue(double x, double f);
    void addFrozenFrames(int afterFrame, int nFrames, double value);
    void computeInterpolant();
    double evaluateInterpolant(double x) const;
    double evaluateDerivative(double x) const;

    const std::vector<double> &getXs()     const { return xs;     }
          std::vector<double> &getFs()           { return fs;     }
    const std::vector<double> &getDerivs() const { return derivs; }

private:
    unsigned int findSection(double x) const;

    std::vector<double> xs;
    std::vector<double> fs;
    std::vector<double> derivs;
};

#endif // MONOTONEINTERPOLATOR_H