//
//    Copyright (c) 2011 Thomas J. Cashman and Kai Hormann
//                       Tom.Cashman@cantab.net / Kai.Hormann@usi.ch
//
//    This file is part of DefMeshRep.
//
//    DefMeshRep is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    DefMeshRep is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with DefMeshRep.  If not, see <http://www.gnu.org/licenses/>.
//

varying vec3 normal, eyeVec;
#define NUM_LIGHTS 2
varying vec3 lightDir[NUM_LIGHTS];

void main(void)
{
    vec4 final_color = gl_FrontLightModelProduct.sceneColor;
    vec3 N = normalize(normal);

    int i;
    for (i = 0; i < NUM_LIGHTS; ++i)
    {
        vec3 L = normalize(lightDir[i]);
        float lambertTerm = dot(N,L);
        if (lambertTerm > 0.0)
        {
            final_color += gl_LightSource[i].diffuse *
                           gl_FrontMaterial.diffuse *
                           lambertTerm;
            vec3 E = normalize(eyeVec);
            vec3 R = reflect(-L, N);
            float specular = pow(max(dot(R, E), 0.0),
                                 gl_FrontMaterial.shininess);
            final_color += gl_LightSource[i].specular *
                           gl_FrontMaterial.specular *
                           specular;
        }
    }
	
    gl_FragColor = final_color;
}
