//
//    Copyright (c) 2011 Thomas J. Cashman and Kai Hormann
//                       Tom.Cashman@cantab.net / Kai.Hormann@usi.ch
//
//    This file is part of DefMeshRep.
//
//    DefMeshRep is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    DefMeshRep is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with DefMeshRep.  If not, see <http://www.gnu.org/licenses/>.
//

#include "SelectFileButton.h"

#include <QFileDialog>

SelectFileButton::SelectFileButton(QWidget *parent)
	: QToolButton(parent)
{
	connect(this, SIGNAL(clicked()), this, SLOT(selectFile()));
}

void SelectFileButton::selectFile(void)
{
	 QString fileName = QFileDialog::getOpenFileName(this, tr("File name root"));

	 if (fileName.length() > 0)
	 {
		 emit updateFileName(fileName);
	 }
}
